var App = artifacts.require("App");
var Registry = artifacts.require("RegistryV0");

var OwnershipToken = artifacts.require("OwnershipTokenV0");
var RegistrarToken = artifacts.require("RegistrarTokenV0");

module.exports = function(deployer, network, accounts) {
  deployer.deploy([
    App,
    Registry,
    OwnershipToken,
    RegistrarToken,
  ]).then(async () => {
    var app = await App.deployed();

    await app.addPackage('Registry', Registry.address);
    await app.addPackage('OwnershipToken', OwnershipToken.address);
    await app.addPackage('RegistrarToken', RegistrarToken.address);

    var receipt = await app.create('Registry');
    var registry = await Registry.at(receipt.logs[0].args.addr);
 
    await registry.initialize(app.address, 'DwNS Domain', 'DWNS');
    var token = await registry.ownershipToken();

    await app.set('registry', registry.address);
    await app.set('token', token);
  });
};
