const erc820 = require('erc820');

const deploy = async (web3) => {
  const res = erc820.generateDeployTx();

  console.log("Sender: ", res.sender);
  console.log("Contract:", res.contractAddr);

  const deployedCode = await web3.eth.getCode(res.contractAddr);

  if (deployedCode.length <= 3) {
    await web3.eth.sendTransaction({
      from: web3.eth.accounts[0], to: res.sender, value: '100000000000000000'
    });
    console.log('Sent 0.1 eth to ' + res.sender);

    await web3.eth.sendRawTransaction(res.rawTx);
    console.log('Registry deployed');
  } else {
    console.log('Registry is already deployed');
  }
}

module.exports = function(callback) {
  deploy(web3).then(() => { callback(); });
}
